/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rosbridge-library-0.7.13-0precise-20150814-1810/msg/TestDurationArray.msg
 *
 */


#ifndef ROSBRIDGE_LIBRARY_MESSAGE_TESTDURATIONARRAY_H
#define ROSBRIDGE_LIBRARY_MESSAGE_TESTDURATIONARRAY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rosbridge_library
{
template <class ContainerAllocator>
struct TestDurationArray_
{
  typedef TestDurationArray_<ContainerAllocator> Type;

  TestDurationArray_()
    : durations()  {
    }
  TestDurationArray_(const ContainerAllocator& _alloc)
    : durations(_alloc)  {
    }



   typedef std::vector<ros::Duration, typename ContainerAllocator::template rebind<ros::Duration>::other >  _durations_type;
  _durations_type durations;




  typedef boost::shared_ptr< ::rosbridge_library::TestDurationArray_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rosbridge_library::TestDurationArray_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct TestDurationArray_

typedef ::rosbridge_library::TestDurationArray_<std::allocator<void> > TestDurationArray;

typedef boost::shared_ptr< ::rosbridge_library::TestDurationArray > TestDurationArrayPtr;
typedef boost::shared_ptr< ::rosbridge_library::TestDurationArray const> TestDurationArrayConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rosbridge_library::TestDurationArray_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rosbridge_library

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'rosbridge_library': ['/tmp/buildd/ros-hydro-rosbridge-library-0.7.13-0precise-20150814-1810/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rosbridge_library::TestDurationArray_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rosbridge_library::TestDurationArray_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rosbridge_library::TestDurationArray_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8b3bcadc803a7fcbc857c6a1dab53bcd";
  }

  static const char* value(const ::rosbridge_library::TestDurationArray_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8b3bcadc803a7fcbULL;
  static const uint64_t static_value2 = 0xc857c6a1dab53bcdULL;
};

template<class ContainerAllocator>
struct DataType< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rosbridge_library/TestDurationArray";
  }

  static const char* value(const ::rosbridge_library::TestDurationArray_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "duration[] durations\n\
";
  }

  static const char* value(const ::rosbridge_library::TestDurationArray_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.durations);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct TestDurationArray_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rosbridge_library::TestDurationArray_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rosbridge_library::TestDurationArray_<ContainerAllocator>& v)
  {
    s << indent << "durations[]" << std::endl;
    for (size_t i = 0; i < v.durations.size(); ++i)
    {
      s << indent << "  durations[" << i << "]: ";
      Printer<ros::Duration>::stream(s, indent + "  ", v.durations[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROSBRIDGE_LIBRARY_MESSAGE_TESTDURATIONARRAY_H
